#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
from PyQt4 import QtGui, QtCore
from random import *
from time import *
 
class Snake(QtGui.QWidget):
	def __init__(self, parent = None):
		global xgeschwindigkeit, ygeschwindigkeit, anz, xstein, ystein, time, timer
		global highscore1, highscore2, highscore3, counter, countdownlabel, pauseinfo, height
		
		QtGui.QWidget.__init__(self, parent)
		
		screen = QtGui.QDesktopWidget().screenGeometry()

		self.setWindowTitle('Snake')
		self.setWindowIcon(QtGui.QIcon('icons/Snake.png'))
		
		vbox = QtGui.QVBoxLayout()
		vbox.setSpacing(0)
		vbox.setMargin(0)
		
		flaeche = QtGui.QWidget()
		flaeche.setStyleSheet("QWidget { background-color: #88BB88 }")
		
		if screen.height() >= 800:
			height = 600
		else:
			height = screen.height()-200-(screen.height()-200)%15
		
		flaeche.setMinimumHeight(height)
		flaeche.setMinimumWidth(height)
		flaeche.setMaximumHeight(height)
		flaeche.setMaximumWidth(height)
		
		grid = QtGui.QGridLayout()
		grid.setSpacing(4)
		
		buttonlevel1 = QtGui.QPushButton("Level &1")
		buttonlevel1.setFocusPolicy(QtCore.Qt.NoFocus)
		buttonlevel2 = QtGui.QPushButton("Level &2")
		buttonlevel2.setFocusPolicy(QtCore.Qt.NoFocus)
		buttonlevel3 = QtGui.QPushButton("Level &3")
		buttonlevel3.setFocusPolicy(QtCore.Qt.NoFocus)
		
		self.labelhighscore1 = QtGui.QLabel("Highscore: %i" % highscore1)
		self.labelhighscore1.setAlignment(QtCore.Qt.AlignCenter)
		self.labelhighscore2 = QtGui.QLabel("Highscore: %i" % highscore2)
		self.labelhighscore2.setAlignment(QtCore.Qt.AlignCenter)
		self.labelhighscore3 = QtGui.QLabel("Highscore: %i" % highscore3)
		self.labelhighscore3.setAlignment(QtCore.Qt.AlignCenter)
		
		grid.addWidget(buttonlevel1, 0, 0)
		grid.addWidget(buttonlevel2, 0, 1)
		grid.addWidget(buttonlevel3, 0, 2)
		
		grid.addWidget(self.labelhighscore1, 1, 0)
		grid.addWidget(self.labelhighscore2, 1, 1)
		grid.addWidget(self.labelhighscore3, 1, 2)
		
		buttonende = QtGui.QPushButton("&Exit")
		grid.addWidget(buttonende, 3, 1)
		self.labelcounter = QtGui.QLabel("Score: %i" % counter)
		self.labelcounter.setAlignment(QtCore.Qt.AlignCenter)
		grid.addWidget(self.labelcounter, 4, 1)
		
		vbox.addWidget(flaeche)
		vbox.addLayout(grid)
		self.setLayout(vbox)
		self.setFocus()
		
		self.connect(buttonlevel1, QtCore.SIGNAL('clicked()'), self.level1)
		self.connect(buttonlevel2, QtCore.SIGNAL('clicked()'), self.level2)
		self.connect(buttonlevel3, QtCore.SIGNAL('clicked()'), self.level3)
		self.connect(buttonende, QtCore.SIGNAL('clicked()'), QtCore.SLOT('close()'))
		
		self.head = []			#bilder des kopfes laden
		for i in range(0,4,1):
			self.head.append("")
			self.head[i] = []
			for j in range(0,3,1):
				self.head[i].append("")
		self.head[0][0] = QtGui.QPixmap("icons/headl1.png")
		self.head[0][1] = QtGui.QPixmap("icons/headl2.png")
		self.head[0][2] = QtGui.QPixmap("icons/headl3.png")
		self.head[1][0] = QtGui.QPixmap("icons/headu1.png")
		self.head[1][1] = QtGui.QPixmap("icons/headu2.png")
		self.head[1][2] = QtGui.QPixmap("icons/headu3.png")
		self.head[2][0] = QtGui.QPixmap("icons/headr1.png")
		self.head[2][1] = QtGui.QPixmap("icons/headr2.png")
		self.head[2][2] = QtGui.QPixmap("icons/headr3.png")
		self.head[3][0] = QtGui.QPixmap("icons/headd1.png")
		self.head[3][1] = QtGui.QPixmap("icons/headd2.png")
		self.head[3][2] = QtGui.QPixmap("icons/headd3.png")
		
		self.timer = QtCore.QBasicTimer()
		
		self.timer2 = QtCore.QTimer()
		self.connect(self.timer2, QtCore.SIGNAL('timeout()'), self.countdown)
		
	def start(self):
		global xgeschwindigkeit, ygeschwindigkeit, anz, xstein, ystein, time, snakepart, height
		
		self.snakepart = []
		
		for i in range(0,anz,1):
			self.snakepart.append("")
			self.snakepart[i] = QtGui.QLabel(self)
			self.snakepart[i].setGeometry(height - (height/15)//2*15, height-(height/15)//2*15-i*15, 15, 15)
			self.p = QtGui.QPixmap("icons/bild.png")
			self.snakepart[i].setPixmap(self.p)
			self.snakepart[i].show()
		self.snakepart[2].setPixmap(self.head[3][0])
		
		seed()
		xstein = randint(0, height/15-1)
		seed()
		ystein = randint(0, height/15-1)
		
		self.stein = QtGui.QWidget(self)
		self.stein.setStyleSheet("QWidget { background-color: #0000FF }")
		self.stein.setGeometry(15*xstein, 15*ystein, 15, 15)
		self.stein.show()
	
	def timerEvent(self, event):
		global xgeschwindigkeit, ygeschwindigkeit, buttoncontrol, anz, snakepart, counter, labelcounter, liste, height, steps, helpsteps
		
		buttoncontrol = 0
		helpsteps += 1
		steps += helpsteps%2		#every 2nd step --> different head-picture
		
		x0 = self.snakepart[liste[0]].x() + xgeschwindigkeit
		y0 = self.snakepart[liste[0]].y() + ygeschwindigkeit
		
		if x0 == xstein*15 and y0 == ystein*15:
			anz += 1
			liste.append(anz-1)
			self.snakepart.append("")
			self.snakepart[anz-1] = QtGui.QLabel(self)
			self.snakepart[anz-1].setGeometry(self.snakepart[liste[anz-2]].x(), self.snakepart[liste[anz-2]].y(), 15, 15)
			self.snakepart[anz-1].setPixmap(self.p)
			self.snakepart[anz-1].show()
			
			counter += 1
			self.labelcounter.setText("Score: %i" % counter)
			
			self.set()
			for i in range(0,anz,1):
				if 15*xstein == self.snakepart[liste[i]].x() and 15*ystein == self.snakepart[liste[i]].y():
					self.snakepart[liste[i]].show()
		
		if x0 < 0 or x0 >= height-10 or y0 < 0 or y0 >= height-10:
			self.timer.stop()
			self.lose()
		else:	
			self.snakepart[liste[anz-1]].move(x0, y0)
			
			if xgeschwindigkeit//15 == 0:
				self.snakepart[liste[anz-1]].setPixmap(self.head[2+ygeschwindigkeit//15][steps%3])
			else:
				self.snakepart[liste[anz-1]].setPixmap(self.head[1+xgeschwindigkeit//15][steps%3])
			
			dummy = liste[anz-1]
			for i in range(anz-1,0,-1):
				liste[i] = liste[i-1]
			liste[0] = dummy
			self.snakepart[liste[1]].setPixmap(self.p)
		
		try:
			for i in range(1,anz,1):
				if self.snakepart[liste[0]].x() == self.snakepart[liste[i]].x() and self.snakepart[liste[0]].y() == self.snakepart[liste[i]].y():
					self.timer.stop()
					self.lose()
		except:
			pass
	
	def keyPressEvent(self, event):
		global xgeschwindigkeit, ygeschwindigkeit, pausecontrol, buttoncontrol, anz, height
		
		if buttoncontrol == 0 and event.key() == QtCore.Qt.Key_Left and xgeschwindigkeit == 0 and pausecontrol == 0:
			xgeschwindigkeit = -15
			ygeschwindigkeit = 0
			buttoncontrol = 1
		
		if buttoncontrol == 0 and event.key() == QtCore.Qt.Key_Right and xgeschwindigkeit ==0 and pausecontrol == 0:
			xgeschwindigkeit = 15
			ygeschwindigkeit = 0
			buttoncontrol = 1
		
		if buttoncontrol == 0 and event.key() == QtCore.Qt.Key_Up and ygeschwindigkeit == 0 and pausecontrol == 0:
			xgeschwindigkeit = 0
			ygeschwindigkeit = -15
			buttoncontrol = 1
		
		if buttoncontrol == 0 and event.key() == QtCore.Qt.Key_Down and ygeschwindigkeit == 0 and pausecontrol == 0:
			xgeschwindigkeit = 0
			ygeschwindigkeit = 15
			buttoncontrol = 1
		
		if event.key() == QtCore.Qt.Key_Space and pausecontrol == 1:
			self.timer.start(time, self)
			pausecontrol = 0
		
		elif event.key() == QtCore.Qt.Key_Space and pausecontrol == 0:
			self.timer.stop()
			pausecontrol = 1
	
	def set(self):
		global xstein, ystein, height
		
		seed()
		xstein = randint(0, height/15-1)
		seed()
		ystein = randint(0, height/15-1)
		
		self.stein.move(15*xstein, 15*ystein)
	
	
	def level1(self):
		global time, active, timer, fast, timer2, countdownactive, height
		time = slow
		
		if active == 0 and countdownactive == 0:
			self.timer2.start(1000)
		if active == 0 and countdownactive == 1:
			active = 1
			countdownactive = 0
			self.start()
			self.timer.start(time, self)
	
	def level2(self):
		global time, active, timer, fast, timer2, countdownactive, height
		time = medium
		
		if active == 0 and countdownactive == 0:
			self.timer2.start(1000)
		if active == 0 and countdownactive == 1:
			active = 1
			countdownactive = 0
			self.start()
			self.timer.start(time, self)
	
	def level3(self):
		global time, active, timer, fast, timer2, countdownactive
		time = fast
		
		if active == 0 and countdownactive == 0:
			self.timer2.start(1000)
		if active == 0 and countdownactive == 1:
			active = 1
			countdownactive = 0
			self.start()
			self.timer.start(time, self)
	
	def lose(self):
		global anz, active, snakepart, stein, xgeschwindigkeit, ygeschwindigkeit, slow, medium, fast, counter
		global highscore1, highscore2, highscore3, counter, liste, height
		
		active = 0
		xgeschwindigkeit = 0
		ygeschwindigkeit = 15
		self.stein.deleteLater()
		self.stein = None
		for i in range(0, anz, 1):
			self.snakepart[i].deleteLater()
			self.snakepart[i] = None
		anz = 3
		liste = [0, 1, 2]
		
		if (time == slow) and (counter > highscore1):
			highscore1 = counter
			QtGui.QMessageBox.information(None, "End", "Congratulations! You achieved a new record!")
			d = open("highscore1", "w")
			d.write(str(counter))
			d.close()
			self.labelhighscore1.setText("Highscore: " + str(counter))
		elif (time == medium) and (counter > highscore2):
			highscore2 = counter
			QtGui.QMessageBox.information(None, "End", "Congratulations! You achieved a new record!")
			d = open("highscore2", "w")
			d.write(str(counter))
			d.close()
			self.labelhighscore2.setText("Highscore: " + str(counter))
		elif (time == fast) and (counter > highscore3):
			highscore3 = counter
			QtGui.QMessageBox.information(None, "End", "Congratulations! You achieved a new record!")
			d = open("highscore3", "w")
			d.write(str(counter))
			d.close()
			self.labelhighscore3.setText("Highscore: " + str(counter))
		else:
			QtGui.QMessageBox.information(None, 'End', 'Sorry! You have lost.')
		
		counter = 0
		self.labelcounter.setText("Score: " + str(counter))
	
	def countdown(self):
		global countdowncounter, countdownlabel, pauseinfo, timer2, countdownactive, time, height
		
		self.countdownlabel = QtGui.QLabel("<font size = 30>" + str(countdowncounter) + "</font>", self)
		self.countdownlabel.setStyleSheet("QLabel { background-color: #88BB88; font-size:40pt}")
		self.countdownlabel.setAlignment(QtCore.Qt.AlignCenter)
		clabelsize = self.countdownlabel.geometry()
		self.countdownlabel.setGeometry(height//2-40, height//2-80, 80, 80)
		
		self.pauseinfo = QtGui.QLabel("Pause/Continue: Space-Bar", self)
		if height == 600:
			self.pauseinfo.setStyleSheet("QLabel { background-color: #88BB88; font-size:15pt}")
		else:
			self.pauseinfo.setStyleSheet("QLabel { background-color: #88BB88; font-size:10pt}")
		self.pauseinfo.setAlignment(QtCore.Qt.AlignCenter)
		plabelsize = self.pauseinfo.geometry()
		self.pauseinfo.setGeometry(height//2-125, height//2+20, 250, 50)
		self.countdownlabel.show()
		self.pauseinfo.show()
		
		if countdowncounter > 0:
			self.countdownlabel.setText(str(countdowncounter))
			countdowncounter -= 1
		else:
			self.countdownlabel.clear()
			countdowncounter = 3
			self.pauseinfo.clear()
			self.timer2.stop()
			countdownactive = 1
			if time == fast:
				self.level3()
			elif time == medium:
				self.level2()
			else:
				self.level1()


xgeschwindigkeit = 0
ygeschwindigkeit = 15
pausecontrol = 0
buttoncontrol = 0
anz = 3
active = 0
slow = 80
medium = 60
fast = 44
counter = 0
countdowncounter = 3
countdownactive = 0
liste = [0, 1, 2]
helpsteps = 0
steps = 0

try:
	d = open("highscore1")
	zeilen = d.readlines()
	for z in zeilen:
		highscore1 = int(z)
	d.close()
except:
	highscore1 = 0
try:
	d = open("highscore2")
	zeilen = d.readlines()
	for z in zeilen:
		highscore2 = int(z)
	d.close()
except:
	highscore2 = 0
try:
	d = open("highscore3")
	zeilen = d.readlines()
	for z in zeilen:
		highscore3 = int(z)
	d.close()
except:
	highscore3 = 0


prog = QtGui.QApplication(sys.argv)
snake = Snake()
snake.show()
sys.exit(prog.exec_())